package com.heyang;

import com.heyang.util.BracketChecker;
import com.heyang.util.CommonUtil;
import com.heyang.util.Renderer;

public class EntryPoint {
	public static void main(String[] args) {
		try {
			// Read context from file
			String jsonTxt=CommonUtil.readTextFromFile("C:\\hy\\files\\xml\\01.xml");
			System.out.println("ԭ="+jsonTxt);
			
			// Is brackets balanced
			BracketChecker checker=new BracketChecker();
			boolean isBalanced=checker.isBalanced(jsonTxt);
			if(isBalanced==false) {
				System.out.println(Renderer.paintBrown(checker.getErrMsg()));
				return;
			}
			
			// Parse json to tokens
			Lexer lex=new Lexer(jsonTxt);
			//System.out.println("ı="+lex.getCompactJsonTxt());
			//lex.printTokens();
			
			// Build tree
			TreeBuilder builder=new TreeBuilder(lex.getTokens());
			Node root=builder.getRoot();
			System.out.println("κı:\n"+root);
		}catch(Exception ex) {
			System.out.println(Renderer.paintBrown(ex.getMessage()));
			ex.printStackTrace();
		}
	}
}
