package com.heyang;

import java.util.List;

public class TreeBuilder {
	private Node root;
	private List<Token> tokens;
	private int tokenIdx;
	
	public TreeBuilder(List<Token> tokens) throws Exception{
		this.tokens=tokens;
		this.tokenIdx=0;
		
		root=new Node();
		parseNode(root);
	}
	
	private void parseNode(Node parent) throws Exception{
		Token token;
        
        token=fetchToken();
        if(token.getType()!=Token.TYPE_OPEN_ANGLEBRACKET) {
            throw new Exception("Expected:'<' actual:"+token.getText()+" "+token);
        }

        token=fetchToken();
        if(token.getType()!=Token.TYPE_TEXT) {
        	throw new Exception("Expected:text actual:"+token.getText()+" "+token);
        }
        
        // get node name
        parent.setName(token.getText());
        
        // get properties
        for(;;) {
        	token=fetchToken();
        	if(token.getType()!=Token.TYPE_TEXT) {
        		// ,˻ز˳
        		returnToken();
            	break;
            }
        	
        	String name=token.getText();
        	
        	// =
        	token=fetchToken();
            if(token.getType()!=Token.TYPE_EQUAL) {
            	throw new Exception("Expected:= actual:"+token.getText()+" "+token);
            }
            
            token=fetchToken();
        	if(token.getType()!=Token.TYPE_TEXT) {
        		throw new Exception("Expected:= actual:"+token.getText()+" "+token);
            }
        	
        	String value=token.getText();
        	
        	parent.addProperty(new Property(name,value));
        }
        
        
        token=fetchToken();
        if(token.getType()==Token.TYPE_EMPTY_CLOSE) {
        	// ڵ,ӽڵ,ı
        	return;
        }else if(token.getType()==Token.TYPE_CLOSE_ANGLEBRACKET) {
        	// ӽڵı,
        }else {
        	// δ,׳쳣
        	throw new Exception("Expected:'>' actual:"+token.getText()+" "+token);
        }
        
        // ȡıӽڵ
        for(;;) {
        	token=fetchToken();
        	
        	if(token.getType()==Token.TYPE_TEXT) {
            	// ȡı
            	parent.setText(token.getText());
            }else if(token.getType()==Token.TYPE_OPEN_ANGLEBRACKET)  {
            	// TODO:ȡӽڵ,ӽڵ,ݹ
            	Node child=new Node();
            	parent.addChild(child);
            	
            	returnToken();
            	parseNode(child);
            }else {
            	// ,˻ز˳
        		returnToken();
            	break;
            }
        }
        
        token=fetchToken();
        if(token.getType()!=Token.TYPE_END_OPEN) {
        	throw new Exception("Expected:'</' actual:"+token.getText()+" "+token);
        }
        
        token=fetchToken();
        if(token.getType()!=Token.TYPE_TEXT) {
        	throw new Exception("Expected:text actual:"+token.getText()+" "+token);
        }
        
        String name=token.getText();
        if(!name.equals(parent.getName())) {
        	throw new Exception("Expected node name:"+parent.getName()+" actual:"+name+" "+token);
        }
        
        token=fetchToken();
        if(token.getType()!=Token.TYPE_CLOSE_ANGLEBRACKET) {
        	throw new Exception("Expected:'>' actual:"+token.getText()+" "+token);
        }
	}
	
	private Token fetchToken() {
		if(tokenIdx>=tokens.size()) {
			return null;
		}else {
			Token t=tokens.get(tokenIdx);
			tokenIdx++;
			return t;
		}		
	}
	
	private void returnToken() {
		if(tokenIdx>0) {
			tokenIdx--;
		}
	}
	
	public Node getRoot() {
		return root;
	}
}
